<?php

namespace App\Services;

use RuntimeException;
use App\Models\UserModel;
use App\Helpers\UserHelper;
use App\Forms\UserForm;
use App\Entities\UserEntity;
use App\Entities\CommonEntity;
use App\DTOs\UserDTO;

class UserService extends CommonService
{
    protected string $formClass = UserForm::class;
    protected string $helperClass = UserHelper::class;

    public function __construct(UserModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('User');
    }
    public function getDTOClass(): string
    {
        return UserDTO::class;
    }
    public function createDTO(array $formDatas): UserDTO
    {
        return new UserDTO($formDatas);
    }
    public function getEntityClass(): string
    {
        return UserEntity::class;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): UserEntity
    {
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    public function setFilter(string $field, mixed $filter_value): void
    {
        switch ($field) {
            case 'role':
                //FIND_IN_SET()은 MySQL 함수이므로 CodeIgniter가 이를 일반 컬럼명으로 착각하고 escape하게 되면 오류가 발생
                // 따라서 ->where($sql, null, false)로 명시하여 escape를 꺼줘야 정상 작동
                $where = "FIND_IN_SET(" . $this->model->escape($filter_value) . ", {$this->model->getTable()}.{$field}) > 0";
                $this->model->where($where, null, false);
                break;
            default:
                parent::setFilter($field, $filter_value);
                break;
        }
    }
    //검색어조건절처리
    public function setSearchWord(string $word): void
    {
        $this->model->orLike($this->model->getTable() . '.id', $word, 'both');
        $this->model->orLike($this->model->getTable() . '.email', $word, 'both');
        parent::setSearchWord($word);
    }
}
